
VERSION="1.1.4"

# 调试模式标记
DEBUG_FLAG=false

SKIPMOUNT=false
PROPFILE=false
POSTFSDATA=false
LATESTARTSERVICE=false
is_beifen=false
yulan=false
xdc=false

var_device="`getprop ro.product.board`"
var_version="`grep_prop ro.build.version.release`"
time1=$(date +%H%M%S)

source $TMPDIR/split.sh
on_install() {

  # 解压文件
  unzip -o "$ZIPFILE" 'mods/*' -d "$TMPDIR/" >&2
  # 公用函数
  source $TMPDIR/util_funcs.sh
  #测试音量键
  testkey

  # 替换文件夹列表
  REPLACE=""

  source $TMPDIR/module_detection.sh

  # 已安装模块
  MODS_SELECTED_YES=""
  MODS_SELECTED_NO=""
  
  # 自定义
  ui_print "   解压缩文件......(总文件共106M，压缩后51M，解压缩时间较长请耐心等待)"
  time3=$(date +%H%M%S)
  tar -xf $TMPDIR/指纹特效.tar.xz -C $TMPDIR 2>/dev/null
  time4=$(date +%H%M%S)
  let "t1=time4-time3"
  echo "- 本次解压共用时$t1 s"
  ui_print "- 检测系统指纹目录ing"
  a=$(unzip -l /system/priv-app/MiuiSystemUI/MiuiSystemUI.apk | egrep finger_image_light)
  a=${a#*/}
  a=${a%%/*}
  ui_print "- 检测到指纹目录为$a"
  ui_print "- 创建临时指纹目录"
  mkdir -p $MODPATH/zhiwen/res/drawable-xxhdpi
  mkdir -p $MODPATH/zhiwen/nightmode/res/drawable-xxhdpi        
  mkdir -p $MODPATH/zhiwen/res/$a
  mkdir -p $MODPATH/zhiwen/nightmode/res/$a
  if [ -e "/data/system/theme/com.android.systemui" ];then
    ui_print "检测到主题中含有系统UI模组，正在合并"
    mkdir -p $MODPATH/zhiwen
    unzip -o /data/system/theme/com.android.systemui -d $MODPATH/zhiwen >&2
  fi

  MODFILE=/data/adb/modules/zhiwentexiao_xin1
  # 加载存档/可用选项
  if [ -f $MODFILE/beifen ]; then
     ui_print "  - 检测到你曾经有通过此模块做出的选择，是否沿用曾经的选择？"
    source $MODFILE/jieshao
    yiliu=$(cat $MODFILE/jieshao | grep 'description')
     ui_print "  - 你曾经的选择：${yiliu:12} - "
     ui_print "  - 请按音量键选择 -"
     ui_print "   [音量+]：沿用曾经的选择"
     ui_print "   [音量-]：我重新做选择"
   if $VOLKEY_FUNC; then
    is_beifen=true
   else
    rm -rf $MODFILE/jieshao
    rm -rf $MODFILE/beifen
   fi
  fi
   # 加载可用选项
  if $is_beifen; then
   source $MODFILE/beifen
   INSTALLED_FUNC="${yiliu:12}"
  else
   record=0 && modinstall
  fi

  if [ -z "$INSTALLED_FUNC" ]; then
    ui_print "未安装任何功能 即将退出安装..."
    rm -rf $TMPDIR
    exit 1
  else
    ui_print "****************************************"
    ui_print "- 是否安装设置内指纹特效预览(需要重启)"
    ui_print "- [音量+]安装"
    ui_print "- [音量-]不安装"
    if $VOLKEY_FUNC ; then
        ui_print "****************************************"
        ui_print "- 已选择[安装]"
        yulan=true
    else 
        ui_print "****************************************"
        ui_print "- 已选择[不安装]"
    fi
  fi

  time5=$(date +%H%M%S)
  ui_print "- 开始植入主题…(文件较大，压缩时间较长，请耐心等待)"
  source $TMPDIR/install_zhiwen.sh
  if $yulan;then
    ui_print "- 正在替换预览动画…"
    source $TMPDIR/install_yulan.sh
  fi
  rm -rf $MODPATH/*
  echo "$INSTALLED_FUNC" >> $TMPDIR/module.prop
  echo "description=$INSTALLED_FUNC" > $MODFILE/jieshao
  time2=$(date +%H%M%S)
  let "t=time2-time1"
  echo "- 本次刷入共用时$t s"
}
